unit PhylMol;

// 22/01/01 DL ajout chemin molecules  (dfini dans Donnees)
//             et modif de InitialDir de OpenDialog1 dans l'inspecteur d'objets

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, MyNewgrid,dataselmat,CustomGraph,arbre,fenarbre,typedef,
  GraphControlTreeCL, ExtCtrls, Buttons ,donnees;

type
  TFormMol = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    ouvrirfichmol: TButton;
    AfficherArbre: TButton;
    Align: TButton;
    Ajoutmol: TButton;
    OuvrirMat: TButton;
    TabDist1: TTabGrid;
    ButOptions: TButton;
    GraphControlTreeUPGMA1: TGraphControlTreeUPGMA;
    OpenDialog2: TOpenDialog;
    GraphControlTreeNJ1: TGraphControlTreeNJ;
    GCT2: TGraphControlTreeCL;
    BoiteLongueur: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    LongTot: TEdit;
    LongPart: TEdit;
    Panel4: TPanel;
    zoomplus: TSpeedButton;
    annuler: TSpeedButton;
    zoommoins: TSpeedButton;
    normal: TSpeedButton;
    Enraciner: TSpeedButton;
    pivoter: TSpeedButton;
    SpeedButton1: TSpeedButton;
    legendes: TSpeedButton;
    AfficherDistances: TSpeedButton;
    FontDialog2: TFontDialog;
    Label1: TLabel;
    EditFile: TEdit;
    PanelGrilleMol: TPanel;
    Panel6: TPanel;
    MolGrid1: TMolGrid;
    Button1: TButton;
    Button2: TButton;
    alerte_arbre: TLabel; // jfr modifie le 30/04/02
    // jfr modifie le 07/07/00
    procedure ouvrirfichmolClick(Sender: TObject);
    procedure AfficherArbreClick(Sender: TObject);
    procedure AlignClick(Sender: TObject);
    procedure AjoutmolClick(Sender: TObject);
    procedure OuvrirMatClick(Sender: TObject);
    procedure AfficherDistancesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButOptionsClick(Sender: TObject);
  
    procedure GCT2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure zoomplusClick(Sender: TObject);
    procedure zoommoinsClick(Sender: TObject);
    procedure EnracinerClick(Sender: TObject);
    procedure pivoterClick(Sender: TObject);
    procedure normalClick(Sender: TObject);
    procedure MolGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure legendesClick(Sender: TObject);
    procedure GCT2BeforeInsert(sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure annulerClick(Sender: TObject);
    procedure Panel3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ChoixCopieClick(Sender: TObject);
  private
    { Dclarations prives}
   typeArbre:TTypeArbre;
   FFormatDistance : TFormatDistance;
   FCalcDistance : TCalcDistance;
   FBaseCount : TBaseCount;
   FDeleteDistance : TDeleteDistance;
   NameOfFlagTaxonPro: string; // jfr modifie le 07/07/00
   Filename :string;
  public
   GraphTree :TGraphControlTree ;
   // jfr modifie le 07/07/00 :procedures rajoutes
   procedure InvalidateButton;
   procedure ValidateButton;

   procedure SetGraphTreeOptions;

  end;

var
  FormMol: TFormMol;

implementation

uses OptionsMol, PhylMain ;

{$R *.DFM}

// jfr modifie le 10/04/00
procedure TFormMol.ouvrirfichmolClick(Sender: TObject);
var
   //i:integer;
   index1,index2 : integer;
   chaine1, chaine2: String;
begin
  if CheminMolecules<>'' then
    openDialog1.InitialDir:=CheminMolecules
  else if CheminColl<>'' then
    openDialog1.InitialDir:=CheminColl;
  openDialog1.FileName:='';
  if opendialog1.execute then
    begin
      try
        if (pos(CheminMolecules,opendialog1.FileName)=0) then
          begin
            index1:=pos('Collections',opendialog1.FileName);
            if (index1>0) then
              begin
                chaine1:=copy(opendialog1.Filename,index1+12,length(opendialog1.FileName) );
                index2:=pos('/',chaine1);
                if (index2=0) then index2:=pos('\',chaine1);
                chaine2:=copy(chaine1,0,index2-1);
                ShowMessage('Le fichier choisi appartient  la collection  "'+ chaine2 + '" ; ce n''est pas la collection slectionne. Vous devez donc la modifier si vous voulez choisir ce fichier');
              end
            else
              MessageDlg('Le fichier choisi n''appartient pas  la collection slectionne',mtInformation,[mbOK],0);
          end;
        Molgrid1.Loadfromfile(opendialog1.filename);

        if Molgrid1.TypeMol=nul then exit;
        FileName:=extractfilename(opendialog1.filename);

        EditFile.Font.Color:=clBlack;
        EditFile.text:=FileName;

        if graphtree<>nil then graphtree.visible:=false;
        if Tabdist1<>nil then Tabdist1.Visible:=false;      // jfr modifie le 24/06/02
        MolGrid1.SelectAllRow(false);
        AfficherDistances.enabled:=false;
        // DL 14/09/00
        //AfficherDistances.Caption:='Afficher les distances';
        AfficherDistances.Down:=true;

        if (MolGrid1.Typesetmol=setalign)and (MolGrid1.Rowcount>3) then
          begin
           Afficherarbre.enabled:=true;
           alerte_arbre. visible := false ;
           Ouvrirmat.enabled:=true;
          end
        else
          begin
            Afficherarbre.enabled:=false;
            alerte_arbre. visible := true ;
            Ouvrirmat.enabled:=false;
          end;
        Align.enabled:=true;
      except
      end;
    end;
  Button1Click(Sender);
  if (Molgrid1.TypeSetMol=notalign) then Align.enabled:=true else Align.enabled:=false ;
end;
// jfr modifie le 07/07/00 :procedure rajoute
procedure TFormMol.ValidateButton;
 begin
 Annuler.Enabled:=true;
 Zoomplus.enabled:=true;
 Zoommoins.enabled:=true;
 legendes.enabled:=true;
 Enraciner.enabled:=true;
 pivoter.enabled:=true;
 normal.enabled:=true;
 speedbutton1.enabled:=true;
 BoiteLongueur.visible:=true;
 end;

// jfr modifie le 07/07/00 :procedure rajoute
procedure TFormMol.InvalidateButton;
 begin
 Annuler.Enabled:=false;
 Zoomplus.enabled:=false;
 Zoommoins.enabled:=false;
 legendes.enabled:=false;
 Enraciner.enabled:=false;
 pivoter.enabled:=false;
 normal.enabled:=false;
 speedbutton1.enabled:=false;
 BoiteLongueur.visible:=false;
 end;


// jfr modifie le 07/07/00 : procdure change, la partie cladistique est rajoute avec GCT2
procedure TFormMol.AfficherArbreClick(Sender: TObject);
begin

if TabDist1.visible=true then TabDist1.visible:=false;

AfficherDistances.enabled:=true;
Ouvrirmat.enabled:=true;

//DL 14/09/00
//if AfficherDistances.Caption='Effacer les distances' then
//      AfficherDistances.Caption:='Afficher les distances';
  AfficherDistances.Down:=false;

if typeArbre=UPGMA then
  begin
  if GraphControlTreeNJ1.Visible=true then GraphControlTreeNJ1.Visible:=false;
  if GCT2.visible=true then GCT2.Visible:=false;   // jfr modifie le 07/07/00
  GraphControlTreeUPGMA1.Visible:=true;
  GraphTree:=GraphControlTreeUPGMA1;
  SetGraphTreeOptions;
  GraphControlTreeUPGMA1.initTree(molgrid1);
  GraphControlTreeUPGMA1.Invalidate;

 // Ncessaire quand un arbre a t affich avant et que c'tait un arbre Clade qui permet
  // la slection/activation des colonnes
   Molgrid1.SelectAllCol(true);
   MolGrid1._ColInvalidate:=false; // jfr modifie le 07/07/00
   MolGrid1._ColSelect:=false;
   MolGrid1.invalidate;

 InvalidateButton;
 Enraciner.enabled:=false;   // jfr modifie le 15/05/02
 Zoomplus.enabled:=true;
 Zoommoins.enabled:=true;
 pivoter.enabled:=true;
 normal.enabled:=true;


  end
else
if typeArbre=NJ  then
 begin
  if GraphControlTreeUPGMA1.Visible=true then GraphControlTreeUPGMA1.Visible:=false;
  if GCT2.visible=true then GCT2.Visible:=false;   // jfr modifie le 07/07/00

  GraphControlTreeNJ1.Visible:=true;
  GraphTree:=GraphControlTreeNJ1;
  SetGraphTreeOptions;
  GraphControlTreeNJ1.initTree(molgrid1);
  GraphControlTreeNJ1.Invalidate;
  // Ncessaire quand un arbre a t affich avant et que c'tait un arbre Clade qui permet
  // la slection/activation des colonnes
   Molgrid1.SelectAllCol(true);
   MolGrid1._ColInvalidate:=false; // jfr modifie le 07/07/00
   MolGrid1._ColSelect:=false;
   MolGrid1.invalidate;

  InvalidateButton;
  Zoomplus.enabled:=true;
  Zoommoins.enabled:=true;
  Enraciner.enabled:=true;
  pivoter.enabled:=true;
  normal.enabled:=true;
 end
 else
  begin
   if GraphControlTreeUPGMA1.Visible=true then GraphControlTreeUPGMA1.Visible:=false;
   if GraphControlTreeNJ1.Visible=true then GraphControlTreeNJ1.Visible:=false;
   GCT2.visible:=true  ;
   GraphTree:=GCT2;
   MolGrid1._ColInvalidate:=true; // jfr modifie le 07/07/00
   MolGrid1._ColSelect:=true;
   MolGrid1.invalidate;
   GCT2.InitTree(Molgrid1);
   GCT2.invalidate;
   AfficherDistances.enabled:=false;

   Ouvrirmat.enabled:=false;
   ValidateButton;
   legendes.enabled:=false;       // jfr modifie septembre 2001 pour que le bouton soit dsactiv quand l'arbre clade s'affiche

   LongTot.Text:=intToStr(GCT2.TreeTotalLength);
   LongPart.Text:=intToStr(GCT2.TreeUnitLength);
 end;
end;

procedure TFormMol.AlignClick(Sender: TObject);
begin
 if Cheminclustal='oui' then
   Molgrid1.MyALignerOld(true)
 else
   Molgrid1.MyALigner(true);
 FormPrinc.FlagALigner:=true;
 //FormPrinc.EnregistrerMatrice1.enabled:=true;
 FormPrinc.EnregistrerTableau.Enabled:=True;

 if(MolGrid1.Typesetmol=setalign)and (MolGrid1.Rowcount>3) then
 begin

   if graphtree<>nil then graphtree.visible:=false;
   AfficherDistances.enabled:=false;
// DL 14/09/00
//   AfficherDistances.Caption:='Afficher les distances' ;
   AfficherDistances.Down:=false;

   Afficherarbre.enabled:=true;
   Ouvrirmat.enabled:=true;
   alerte_arbre. visible := false ;

   Molgrid1.SelectAllCol(true);
   Molgrid1.SelectAllRow(true);
   MolGrid1.invalidate;
   
  end;
end;

procedure TFormMol.AjoutmolClick(Sender: TObject);
var
  temp:string;
begin
  openDialog2.InitialDir:=GetcurrentDir;
  if opendialog2.execute then
    begin
 // jfr modifie septembre 2001
 temp:=OpenDialog2.Files.Strings[0];
 if ((ExtractFileExt(temp)='.aln') or (ExtractFileExt(temp)='.pir')or (ExtractFileExt(temp)=''))
 then
   begin
    Application.messagebox('Impossible de rajouter ce type de molcules','Erreur', MB_OK);
    exit;
   end; 
 // jfr modifie le 30/04/02 : les trois lignes suivantes ont t ajoutes
 Molgrid1.Loadfromfiles(opendialog2.files);
 EditFile.Font.Color:=clblue;
 EditFile.text:=FileName;

  if graphtree<>nil then graphtree.visible:=false;
   AfficherDistances.enabled:=false;
   // DL 14/09/00
   //   AfficherDistances.Caption:='Afficher les distances';
  AfficherDistances.Down:=false;
  Afficherarbre.enabled:=false;
  alerte_arbre. visible := true ;

  Ouvrirmat.enabled:=false;

 if Molgrid1.rowcount>2 then Align.enabled:=true;
 end;
end;

procedure TFormMol.OuvrirMatClick(Sender: TObject);
begin
  if GraphTree=nil then
  begin
    if typeArbre=UPGMA then  GraphTree:=GraphControlTreeUPGMA1
    else GraphTree:=GraphControlTreeNJ1
  end;
// DL 14/09/00
//  Afficherdistances.Caption:='Afficher les distances';
  AfficherDistances.Down:=false;
  AfficherDistances.enabled:=false ;

  setGraphTreeOptions;
  GraphTree.initTree(molgrid1);
  TGraphControlTreeDist(GraphTree).TabDistCreate(TabDist1);
  TabDist1.Visible:=true;
  GraphControlTreeUPGMA1.Visible:=false;
  GraphControlTreeNJ1.Visible:=false;

  // jfr modifie le 07/07/00
  GCT2.visible:=false;
  InvalidateButton;
end;

procedure TFormMol.AfficherDistancesClick(Sender: TObject);
begin
 if GraphTree=nil then exit;
// DL 14/09/00
// if Afficherdistances.Caption='Afficher les distances' then
  if Afficherdistances.Down then
  begin

  setGraphTreeOptions;
  GraphTree.initTree(molgrid1);
// DL 14/09/00
//  Afficherdistances.Caption:='Effacer les distances';
  TGraphControlTreeDist(GraphTree) .TreePage.Flag_Legende:=true;

   end
  else
  begin

// DL 14/09/00
//   Afficherdistances.Caption:='Afficher les distances';
   TGraphControlTreeDist(GraphTree).TreePage.Flag_Legende:=false ;
   TGraphControlTreeDist(GraphTree).TreePage.DeleteLeg;
  end;
  TGraphControlTreeDist(GraphTree).visible:=true;
  TGraphControlTreeDist(GraphTree).Invalidate;

end;
procedure TFormMol.setGraphTreeOptions;
 begin
   if GraphTree<>nil then
    begin
     TGraphControlTreeDist(GraphTree).FormatDistance:=FFormatDistance;
     TGraphControlTreeDist(GraphTree).BaseCount:=FBaseCount;
     TGraphControlTreeDist(GraphTree).DeleteDistance:=FDeleteDistance;
     TGraphControlTreeDist(GraphTree).CalcDistance:=FCalcDistance;
     end;
 end;
 
procedure TFormMol.FormCreate(Sender: TObject);
begin
FormPrinc.Fille(Self);
GraphTree :=nil;
typeArbre:=UPGMA;  // JFR modifie le 07/07/00  NJ;
FFormatDistance :=Tabsolute;   // JFR modifie le 07/07/00 TPercentage;
NameOfFlagTaxonPro:='';        // JFR modifie le 07/07/00
Molgrid1.SelectAllRow(false);   // JFR modifie le 07/07/00
Molgrid1.SelectAllCol(false);   // JFR modifie le 07/07/00
FCalcDistance :=observed;
FBaseCount :=allbase;
FDeleteDistance :=allremoved;
AfficherDistances.enabled:=false;
Afficherarbre.enabled:=false;
alerte_arbre. visible := true ;
Ouvrirmat.enabled:=false;
Align.enabled:=false;
Button1Click(Sender);
GCT2.MontrerAncetre:=False;
GraphControlTreeUPGMA1.MontrerAncetre:=False;
GraphControlTreeNJ1.MontrerAncetre:=False;
end;

procedure TFormMol.ButOptionsClick(Sender: TObject);
var
  res :integer;
begin

  if typeArbre=NJ then OptionForm.RadNJ.Checked:=true
  else if typeArbre=UPGMA then OptionForm.RadUPGMA.Checked:=true  // jfr modifie le 07/07/00
  else OptionForm.RadCL.Checked:=true;   // jfr modifie le 07/07/00  RadCL rajout

  if FFormatDistance =TPercentage then OptionForm.Radpoucent.checked:=true;
  if FFormatDistance =TAbsolute then OptionForm.RadAbsolu.checked:=true;
  if FFormatDistance =TProportion then OptionForm.Radpropor.checked:=true;

  if FCalcDistance =observed then OptionForm.RadioDistObs.checked:=true;
  if FCalcDistance =poisson then OptionForm.RadDistpoi.checked:=true;
  if FCalcDistance =kimura then OptionForm.RadDistkim.checked:=true;

  if Fdeletedistance=allremoved then  OptionForm.Radignoall.checked:=true;
  if Fdeletedistance=removed then  OptionForm.Radignopaire.checked:=true;
  if Fdeletedistance=scored then  OptionForm.Radcompt.checked:=true;

  res:=OptionForm.showModal;

  if res<>mrcancel then
    begin
      if OptionForm.RadNJ.Checked=true then    // jfr modifie le 10/09/00 pour qu'un changement
        begin                                  // de l'option arbre se rpercute immdiatement
          if typeArbre<>NJ then begin typeArbre:=NJ;AfficherArbreClick(Sender);end;
        end
      else if OptionForm.RadUPGMA.Checked=true then
        begin
          if typeArbre<>UPGMA then begin typeArbre:=UPGMA;AfficherArbreClick(Sender);end;
        end
                         // jfr modifie le 07/07/00
      else if OptionForm.RadCL.checked=true then
        if typeArbre<>CLAD then
          begin
            typeArbre:=Clad;
            // vrifier qu'il y a des taxons slectionns
            if AfficherArbre.Enabled then
              AfficherArbreClick(Sender);
          end;

if OptionForm.Radpoucent.checked=true then FFormatDistance:=TPercentage;
if OptionForm.RadAbsolu.checked=true then FFormatDistance :=TAbsolute ;
if OptionForm.Radpropor.checked=true then FFormatDistance :=TProportion ;

if OptionForm.RadioDistObs.checked=true then FCalcDistance :=observed;
if OptionForm.RadDistpoi.checked=true then FCalcDistance :=poisson;
if OptionForm.RadDistkim.checked=true then FCalcDistance :=kimura;

if OptionForm.Radignoall.checked=true then Fdeletedistance:=allremoved ;
if OptionForm.Radignopaire.checked=true then Fdeletedistance:=removed  ;
if OptionForm.Radcompt.checked=true then  Fdeletedistance:=scored;
end;
end;

// jfr modifie le 10/07/00
// Toutes les fonctions qui suivent ont t rajoutes
procedure TFormMol.GCT2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
 {var
  row :integer;}
begin
// La deuxime condition traduit le fait que le greffage russi d'un taxon
// provisoire conduit  sa suppression
{if (NameOfFlagTaxonPro<>'') and (GCT2.NameOfFlagTaxonPro='') then
 begin
  row:=MolGrid1.IndexOfRow(NameOfFlagTaxonPro);
  if row<>-1 then
   begin
    //TabGrid1.InvalidateRow[row]:=false;
    MolGrid1. SelectRow[row]:=true;
    MolGrid1.MyInvalidateCell(0,row);
    GCT2.AddTaxonToDataList(row);
    end;
   NameOfFlagTaxonPro:='';
 end;  }

LongTot.Text:=intToStr(GCT2.TreeTotalLength);
LongPart.Text:=intToStr(GCT2.TreeUnitLength);

end;

procedure TFormMol.zoomplusClick(Sender: TObject);
begin
if (typeArbre=NJ) then
 GraphControlTreeNJ1 .OnChangeScale('plus')
else if (typeArbre=UPGMA) then
 GraphControlTreeUPGMA1 .OnChangeScale('plus')
 else
GCT2.OnChangeScale('plus');

end;

procedure TFormMol.zoommoinsClick(Sender: TObject);
begin
if (typeArbre=NJ) then
 GraphControlTreeNJ1 .OnChangeScale('moins')
else if (typeArbre=UPGMA) then
 GraphControlTreeUPGMA1 .OnChangeScale('moins')
 else
GCT2.OnChangeScale('moins');

end;

procedure TFormMol.EnracinerClick(Sender: TObject);
begin
if (typeArbre=NJ) then
 GraphControlTreeNJ1 .OnFlagRoot
else if (typeArbre=UPGMA) then
 GraphControlTreeUPGMA1 .OnFlagRoot
 else
  GCT2.OnFlagRoot ;
end;

procedure TFormMol.pivoterClick(Sender: TObject);
begin
 if (typeArbre=NJ) then
 GraphControlTreeNJ1 .OnFlagSwap
else if (typeArbre=UPGMA) then
 GraphControlTreeUPGMA1 .OnFlagSwap
 else
  GCT2.OnFlagSwap ;
end;


procedure TFormMol.normalClick(Sender: TObject);
begin
if (typeArbre=NJ) then
 GraphControlTreeNJ1 .OnFlagNormal
else if (typeArbre=UPGMA) then
 GraphControlTreeUPGMA1 .OnFlagNormal
 else
  GCT2.OnFlagNormal ;
end;


procedure TFormMol.MolGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
 col,row :integer;
 AName :string;
begin
// jfr modifie le 07/07/00 lignes suivantes rajoutes
  MolGrid1.MouseToCell(X,Y,col,row);

  if (Graphtree=nil)  then
    begin
      if molGrid1.canDeselectRow(1)=true then    // jfr modifie le 28 septembre 2001
        begin
          AfficherArbre.Enabled :=true  ;
          alerte_arbre. visible := false ;
          ouvrirmat.Enabled:=true;
        end
      else
        begin
          AfficherArbre.Enabled :=false;
          alerte_arbre. visible := true ;
          ouvrirmat.Enabled:=false;
        end;
      exit;
    end;
  if (graphtree.visible=false) then
    begin
      if molGrid1.canDeselectRow(1)=true then    // jfr modifie le 28 septembre 2001
        begin
          AfficherArbre.Enabled :=true;
          ouvrirmat.Enabled:=true;
          alerte_arbre. visible := false ;
          if Tabdist1.visible=true  then
            begin
              OuvrirMatClick(Sender);
              exit;
            end
          else  exit;
        end;
    end;
  if (typeArbre=UPGMA) or (typeArbre=NJ)  then    // jfr modifie octobre 2001 pour viter qu'prs le rajout d'une molcule
    begin                                            // l'arbre s'affiche
      if (GraphTree <>nil) then
        begin
          if (row<>0) and (col=0) then
            begin
              if molGrid1.canDeselectRow(1)=false then    // jfr modifie le 28 septembre 2001
                begin                                  // pour empecher la dselection quand il ne reste plus que 2 taxons dans l'arbre
                  molgrid1.SelectRow[row]:=true;       // Rappelle la fonction Selfmousedown de myNewgrid qui est appele avant celle ci
                  molgrid1.MyInvalidateCell(col,row);  // a dselectionn automatiquement la cellule; il faut donc la reselectionner
                  exit;                                //   Pour cette raison aussi on appelle canDeselectRow(1) et non pas (2)
                end;
              AfficherArbre.Enabled :=true;
              alerte_arbre. visible := false ;
              AfficherArbreClick(Sender);
              exit;
            end;
        end;
    end;
//


MolGrid1.MouseToCell(X,Y,col,row);
if (row=0) and (col<>0) then     // slection des caractres
 begin
 // JFR modifie le 07/07/00 pour changer l'effet du bouton gauche et du bouton droit
 // Cette modification doit tre combine avec celle de MynewGrid ligne 674
  if (button=mbleft)  then
     begin
      if MolGrid1.InvalidateCol[col]=false then AName:=''
        else
        AName:= 'A. amin:'+intToStr(col);
          if AName='' then  begin
            if GCT2.TreePage.Flag_Legende=true then
              begin
                GCT2.TreePage.Flag_Legende:=false ;
                GCT2.TreePage.DeleteLeg;
              end ;
             legendes.Enabled:=False ;
            // OptionsLegendes.Enabled:=false;
          end
          else legendes.Enabled:=True;

           GCT2.OnChangeSelectCarac(AName);
           GCT2.invalidate;
           LongTot.Text:=intToStr(GCT2.TreeTotalLength);
           LongPart.Text:=intToStr(GCT2.TreeUnitLength);
      end
    else
   begin
     if MolGrid1.SelectCol[col]=false then AName:=''
      else AName:=MolGrid1.Cells[col,row];

     if AName='' then
      begin
      if GCT2.TreePage.Flag_Legende=true then
        begin
          GCT2.TreePage.Flag_Legende:=false ;
          GCT2.TreePage.DeleteLeg;
//          legendes.Caption:='Afficher';
        end ;
       legendes.Enabled:=False ;
      end
    else legendes.Enabled:=True;

    GCT2.OnChangeListCarac(nil, AName);
    GCT2.invalidate;

   LongTot.Text:=intToStr(GCT2.TreeTotalLength);
   LongPart.Text:=intToStr(GCT2.TreeUnitLength);
 end; end;

if (row<>0) and (col=0) then
 begin
  AName:=MolGrid1.Cells[col,row];

// le clic a eu lieu sur une cellule slectionne mais la fonction
// TMyCustomGrid.SelfMouseDown la dselectionne automatiquement si le nombre de cellules
// slectionnes est suprieur  deux.

  if MolGrid1.SelectRow[row]=false then
   begin
   if molGrid1.canDeselectRow(1)=false then    // jfr modifie le 28 septembre 2001
       begin                                     // pour empecher la dselection quand il ne reste plus que 2 taxons dans l'arbre
       molgrid1.SelectRow[row]:=true;            // Rappel la fonction Selfmousedown de myNewgrid qui est appele avant celle ci
       molgrid1.MyInvalidateCell(col,row);       // a dselectionn automatiquement la cellule; il faut donc la reselectionner
       exit;                                     //   Pour cette raison aussi on appelle canDeselectRow(1) et non pas (2)
       end;
      GCT2.DeleteTaxon(AName);
     LongTot.Text:=intToStr(GCT2.TreeTotalLength);
     LongPart.Text:=intToStr(GCT2.TreeUnitLength);

   end
     else  // le clic a eu lieu sur une cellule non selectionne au dpart
           // ou sur une cellule slectionne qui l'est rest (nbselect<=2)
      begin
       if Molgrid1.NbSelectRow > 2 then
        begin
         if GCT2.NameOfFlagTaxonPro='' then
           begin
            GCT2.AddTaxonPro(AName);
            NameOfFlagTaxonPro:=AName;
            MolGrid1. SelectRow[row]:=False;
           // La cellule reste dselectionne tant que le taxon provisoire n'est pas rajout
           end;
         MolGrid1. SelectRow[row]:=False;
        end;
      end;
  end;
end;

procedure TFormMol.legendesClick(Sender: TObject);
begin
 if legendes.Tag=0 then
   begin
     legendes.Tag:=1;
     GCT2.TreePage.Flag_Legende:=true;
     GCT2.TreePage.CreateLeg;
     GCT2.TreePage.ChangeCoordGraphObjects;

   end
   else
     begin
      legendes.Tag:= 0;
      GCT2.TreePage.Flag_Legende:=false;
      GCT2.TreePage.DeleteLeg;
       
     end;
   GCT2.invalidate;
end;

procedure TFormMol.GCT2BeforeInsert(sender: TObject);// jfr modifie le 07/07/00 procedure rajout
var
row:integer;
begin
if (NameOfFlagTaxonPro<>'') then
 begin
  row:=MolGrid1.IndexOfRow(NameOfFlagTaxonPro);
  if row<>-1 then
   begin

    MolGrid1. SelectRow[row]:=true;
    MolGrid1.MyInvalidateCell(0,row);
    GCT2.AddTaxonToDataList(row);
    end;
   NameOfFlagTaxonPro:='';
 end;
end;


procedure TFormMol.FormShow(Sender: TObject);  // JFR modifie le 07/07/00 ajoute
begin
 Molgrid1.SelectAllCol(true);
 //Molgrid1.SelectAllRow(true);
end;

procedure TFormMol.annulerClick(Sender: TObject);
begin
 GCT2.UndoTreeAction;
 LongTot.Text:=intToStr(GCT2.TreeTotalLength);
 LongPart.Text:=intToStr(GCT2.TreeUnitLength);
end;

procedure TFormMol.Panel3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var
  essai:string;
  GCT :TGraphControlTree;
  TreePage:TTreePage;
begin
  if (Button=mbRight) and (Graphtree<>nil) and (graphtree.visible=true) then
  begin
   if FontDialog2.execute then begin
    essai:= FontDialog2.Font.Name;
    if typeArbre=UPGMA then
     begin
     TreePage:=GraphControlTreeUPGMA1.TreePage ;
     GCT:=GraphControlTreeUPGMA1 ;
     end
     else
    if typeArbre=NJ then
     begin
     TreePage:=GraphControlTreeNJ1.TreePage ;
     GCT:=GraphControlTreeNJ1 ;
      end
     else
     begin
     GCT:=GCT2;
     TreePage:=GCT2.treePage;
     end;

    Treepage.FFontTaxon.lfHeight:=FontDialog2.Font.Height;
    if (fsItalic in FontDialog2.Font.style) then Treepage.FFontTaxon.lfItalic := 1
    else  Treepage.FFontTaxon.lfItalic := 0;

    if (fsBold in fontdialog2.Font.style) then Treepage.FFontTaxon.lfweight:= FW_BOLD
    else  Treepage.FFontTaxon.lfweight:= FW_NORMAL;

    if (fsUnderline in fontdialog2.Font.style) then Treepage.FFontTaxon.lfUnderline := 1
    else  Treepage.FFontTaxon.lfUnderline := 0;

    strPCopy(Treepage.FFontTaxon.lfFaceName,essai);
   Treepage.DeleteObjects;
   Treepage.ChangeInfoGraph ;
    gct.invalidate;
    end;
  end;
end;

procedure TFormMol.Button1Click(Sender: TObject);
var
i : integer ;
begin

   for i:=0 to MolGrid1.ListSelectRow.count-1 do
        begin
         // if IsSelectRow(i) then

             MolGrid1.SetSelectRow(i,false);
             MolGrid1.MyInvalidateCell(0,i);

        end;
  AfficherDistances.Down:=false;
  AfficherDistances.enabled:=false ;



  TabDist1.Visible:=false;
  GraphControlTreeUPGMA1.Visible:=false;
  GraphControlTreeNJ1.Visible:=false;

  // jfr modifie le 07/07/00
  GCT2.visible:=false;
  InvalidateButton;
  AfficherArbre.Enabled :=false;
  alerte_arbre. visible := true ;
  OuvrirMat.Enabled := false ;
end;

procedure TFormMol.Button2Click(Sender: TObject);
var
i : integer ;
begin
   MolGrid1.SetSelectRow(0,false);
   for i:=1 to MolGrid1.ListSelectRow.count-1 do
        begin
         // if IsSelectRow(i) then

             MolGrid1.SetSelectRow(i,true);
             MolGrid1.MyInvalidateCell(0,i);

        end;
  if (MolGrid1.TypeSetMol = setalign ) then
    begin
    AfficherArbre.Enabled :=true;
    alerte_arbre. visible := false ;
    OuvrirMat.Enabled := true ;
    end;
 if (GraphControlTreeUPGMA1.Visible=true) or (GraphControlTreeNJ1.Visible=true) or
  (GCT2.visible=true)then   AfficherArbreClick(Sender);
 if (TabDist1.Visible=true)  then  OuvrirMatClick(Sender);

end;

procedure TFormMol.ChoixCopieClick(Sender: TObject);
begin
  ControleACopier:=(Sender as TwinControl);
end;

end.
